/*
** Module   : Initializer.java
** Abstract : Provides access to a type and value.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 GES 20130203 Created initial version.
*/

package com.goldencode.expr;

/**
 * Generates an initial value for a variable.
 */
public abstract class Initializer
{
   /**
    * Evaluate the initializer and return back the result.
    *
    * @return   The initial value.
    */
   public abstract Object resolve();

   /**
    * Report the type of object which will be returned when {@link #resolve}
    * is called.
    *
    * @return   The value's return type.
    */
   public abstract Class<?> getReturnType();
}
